#include <AppKit/AppKit.h>
#include "MainView.api.h"
#include "SubView.api.h"

@implementation MainView

-(BOOL) isOpaque
{
	return YES;
}

-(void) drawRect:(NSRect)rect
{
	NSLog(@"mv dR %@ b%@",
		NSStringFromRect(rect),
		NSStringFromRect([self bounds]));
	[[NSColor greenColor] set];
	[NSBezierPath fillRect: [self bounds]];
	[[NSColor blackColor] set];
}

-(id) initWithFrame:(NSRect)frameRect
{
	NSLog(@"mvInitWithFrame %@", NSStringFromRect(frameRect));

	if (![super initWithFrame:(NSRect)frameRect])
		return nil;

	frameRect.origin = NSZeroPoint;
	if (!(_subView = [[SubView alloc] initWithFrame:frameRect]))
		return nil;
	[self addSubview:_subView];

	return self;
}

-(void) dealloc
{
	NSLog(@"mvDealloc %p", self);
	[_subView release];
	[super dealloc];
}
@end
