#include <AppKit/AppKit.h>
#include "SubView.api.h"

@implementation SubView

- (BOOL) isFlipped
{
	return YES;
}

- (BOOL) isOpaque
{
	return YES;
}

- (void) setFrame: (NSRect)theFrame
{
	NSLog(@"sv sF %@", NSStringFromRect(theFrame));
	[super setFrame:theFrame];
}

- (void)_adjustFrameHeightForNewFrame:(NSRect)newFrame redraw:(BOOL)redraw
{
	NSRect ourFrame = [self frame];
	ourFrame.size.height = newFrame.size.height - _offset;
	ourFrame.origin.y = newFrame.origin.y + _offset;
	[self setFrame:ourFrame];

	if (redraw) {
		[[self superview] setNeedsDisplayInRect:newFrame];
		[self setNeedsDisplay:YES];
	}
}

- (void) drawRect: (NSRect) rect
{
	NSLog(@"sv dR %@ b%@",
		NSStringFromRect(rect),
		NSStringFromRect([self bounds]));
	[[NSColor colorWithDeviceRed: 1.0 green:250.0/255 blue:175.0/255 alpha:1.0] set];
	[NSBezierPath fillRect: [self bounds]];
	[[NSColor blackColor] set];
}

- (void) resizeWithOldSuperviewSize: (NSSize)oldSize
{
	NSView *sv = [self superview];
	NSRect newFrame = [sv frame];

	[self _adjustFrameHeightForNewFrame:newFrame redraw:NO];

	[super resizeWithOldSuperviewSize:oldSize];

	NSLog(@"svResize %@=>%@ b%@",
		NSStringFromSize(oldSize),
		NSStringFromSize(newFrame.size),
		NSStringFromRect([self bounds]));
}

- (id) initWithFrame:(NSRect)frameRect
{
	NSLog(@"svInitWithFrame %@", NSStringFromRect(frameRect));

	if (![super initWithFrame:(NSRect)frameRect])
		return nil;

	[self setAutoresizingMask:NSViewWidthSizable];
	_offset = 10.0;
	[self _adjustFrameHeightForNewFrame:frameRect redraw:YES];

	return self;
}

- (void) dealloc
{
	NSLog(@"svDealloc %p", self);
	[self removeFromSuperviewWithoutNeedingDisplay];
	[super dealloc];
}
@end
